-- threshold, error times in one minute
local err_num = 50
-- how long happening error, minute
local err_minute = 1
local ok = true
local g_ok = true
local g_status = pc_get_global_fault_status()
if g_status >= 1 then
    ngx.log(ngx.ERR,g_status);
    g_ok = false
end

if g_ok then
    for i = 0, err_minute do
        --fail num > $err_num in recent $err_minute mins
        local num = pc_get_fault_num(ngx.time() - i * 60)
        --ngx.log(ngx.ERR,num);
        local status = ngx.shared.pc_status
	key = "pc:a:fault";
	if num >= err_num then
            ok = false
	    status:set(key,1)
            break
	else
	    ok = true
	    status:set(key,0)
        end
    end
end

if g_ok == false or ok == false then
    local url = ngx.var.uri;
    if ngx.var.args then
        url = url .. "?" .. ngx.var.args
    end
    if ngx.var.uri == "/check.php" then
        return ngx.exit(ngx.HTTP_SERVICE_UNAVAILABLE)    
    end
    ngx.var.str_params = url
    ngx.exec("@var")
else
    ngx.exec("@php")
end
